package com.sencorsta.rabs.obj.ai.scene.explore;

import cn.hutool.core.thread.ThreadUtil;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sencorsta.rabs.annotation.SceneAnnotation;
import com.sencorsta.rabs.obj.ai.AiManage;
import com.sencorsta.rabs.obj.ai.api.BaseScene;
import com.sencorsta.rabs.obj.ai.api.Scene;

import java.awt.AWTException;

/**
 * 探索-天赋试炼-怪人
 */
@SceneAnnotation("SceneMain_Explore_Gift")
public class SceneMain_Explore_Gift_Evil extends BaseScene implements Scene {
    @JsonIgnore
    @Override
    public float getPriority() {
        return 3.0f;
    }

    private static String PathEnter = System.getProperty("user.dir") + "\\opencv\\scene\\explore\\gift\\evil\\enter.png";
    private static String PathCheck = System.getProperty("user.dir") + "\\opencv\\scene\\explore\\gift\\evil\\check.png";
    private static String PathBack = System.getProperty("user.dir") + "\\opencv\\scene\\explore\\gift\\evil\\back.png";
    private static String PathOb = System.getProperty("user.dir") + "\\opencv\\scene\\explore\\gift\\evil\\ob.png";
    private static String PathTime10 = System.getProperty("user.dir") + "\\opencv\\scene\\explore\\gift\\evil\\time10.png";
    private static String PathOver = System.getProperty("user.dir") + "\\opencv\\scene\\explore\\gift\\evil\\over.png";
    private static String PathClose = System.getProperty("user.dir") + "\\opencv\\scene\\explore\\gift\\evil\\close.png";

    @Override
    public void back() throws AWTException {
        moveToClick(PathBack, AiManage.getInstance().getCheckPoint());
    }

    @Override
    public void open() throws AWTException {
        while (AiManage.getInstance().isRunning() && !check()) {
            AiManage.getInstance().updateWindow();
            ThreadUtil.sleep(2000);
            if (checkHas(PathEnter, AiManage.getInstance().getCheckPoint())) {
                moveToClick(PathEnter, AiManage.getInstance().getCheckPoint());
                continue;
            }
        }
    }

    @Override
    public boolean check() throws AWTException {
        if (checkHas(PathCheck, AiManage.getInstance().getCheckPoint())) {
            return true;
        }
        return false;
    }

    @Override
    public void think() throws AWTException {
        ThreadUtil.sleep(2000);
        moveToClick(PathOb,AiManage.getInstance().getCheckPoint());
        ThreadUtil.sleep(2000);
        moveToClick(PathTime10,AiManage.getInstance().getCheckPoint());
        while (AiManage.getInstance().isRunning() && !checkHas(PathOver,AiManage.getInstance().getCheckPoint())){
            ThreadUtil.sleep(2000);
        }
        ThreadUtil.sleep(2000);
        moveToClick(PathClose,AiManage.getInstance().getCheckPoint());
        ThreadUtil.sleep(2000);
        getRecord().getData().setDone(true);
    }

    @Override
    public boolean isDone() {
        return getRecord().getData().isDone();
    }

}
